::cane_pickup <- null;

class CanePickup
{
    pickup_ent = null;
    character = null;
    assignedPlayer = null;

    failTS = 0;
    failIsEnabled = false;

    constructor(model, origin, character, team, spawnEnabled = true)
    {
        this.character = character;

        pickup_ent = CreateByClassname("item_armor");
        pickup_ent.DispatchSpawn();
        //pickup_ent.SetModelSimple(model);
        pickup_ent.SetModelSimple("models/vip_mobster/weapons/w_typewriter.mdl");
        pickup_ent.SetAbsOrigin(origin - Vector(0, 0, 20));
        //pickup_ent.SetAbsOrigin(origin - Vector(0, 410, 20));
        pickup_ent.SetTeam(team);
        pickup_ent.SetSolid(SOLID_BBOX);
        pickup_ent.SetSize(Vector(-35, -35, -25), Vector(35, 35, 65));
        pickup_ent.ValidateScriptScope();
        pickup_ent.ConnectOutput("OnCacheInteraction", "OnCacheInteraction");
        local scope = pickup_ent.GetScriptScope();
        scope.script <- this;
        scope.OnCacheInteraction <- OnCaneTouch.bindenv(this);
        cane_pickup = pickup_ent;

        if (spawnEnabled)
            EnablePickup();
        else
            DisablePickup();

        AddTimer(0.1, CaneTempFallback);

        OnGameEvent("vip_gone", function(player, params)
        {
            //if (player == assignedPlayer)
                DoCaneReset();
        });
    }

    function OnCaneTouch()
    {
        if (!assignedPlayer
                && (!activator.IsFakeClient() || activator.GetPlayerClass() != TF_CLASS_SNIPER)
                && activator.GetTeam() == pickup_ent.GetTeam())
            DoCanePickup(activator);
    }

    function DoCanePickup(player)
    {
        failTS = Time() + 5;
        assignedPlayer = player;
        ConvertToCustomCharacter(player, character);
        FireCustomEvent("vip_spawn", {
            userid = player.GetUserID()
        });
        DisablePickup();
    }

    function DoCaneReset()
    {
        assignedPlayer = null;
        EnablePickup();
    }

    function DisablePickup()
    {
        failIsEnabled = false;
        pickup_ent.DisableDraw();
        pickup_ent.SetSolid(SOLID_NONE);

        local entsToKill = [];
        for (local child = pickup_ent.FirstMoveChild(); child != null; child = child.NextMovePeer())
            entsToKill.push(child);
        foreach (ent in entsToKill)
            ent.Kill();
    }

    function EnablePickup()
    {
        failIsEnabled = true;
        pickup_ent.EnableDraw();
        pickup_ent.SetSolid(SOLID_BBOX);

        EntFireByHandle(SpawnEntityFromTable("info_particle_system",
        {
            origin = pickup_ent.GetOrigin() - Vector(0, 0, 20),
            effect_name = "spellbook_major_burning",
            start_active = 1
        }), "SetParent", "!activator", -1, pickup_ent, pickup_ent);
    }

    function CaneTempFallback()
    {
        if (!IsValid(pickup_ent))
            return;
        local frame = GetPropInt(pickup_ent, "m_ubInterpolationFrame");
        pickup_ent.SetAbsAngles(pickup_ent.GetAbsAngles() + QAngle(0, 10, 0));
        SetPropInt(pickup_ent, "m_ubInterpolationFrame", frame);

        if (!failIsEnabled && !FindVIP(TF_TEAM_BLUE) && Time() > failTS) //todo kludge
        {
            printl("failsafe")
            DoCaneReset();
        }
    }
}