function GiveControlPointsVIPLock()
{
    for (local capture_area = null; capture_area = FindByClassname(capture_area, "trigger_capture_area");)
    {
        capture_area.AcceptInput("Disable", null, null, null);

        local trigger_multiple = SpawnEntityFromTable("trigger_multiple", {
            origin = capture_area.GetOrigin(),
            angles = capture_area.GetAbsAngles(),
            spawnflags = 1,
            StartDisabled = 0,
            model = GetPropString(capture_area, "m_ModelName"),
        });
        trigger_multiple.ValidateScriptScope();
        trigger_multiple.ConnectOutput("OnStartTouch", "OnVIPStartTouch");
        trigger_multiple.ConnectOutput("OnEndTouch", "OnVIPEndTouch");

        local scope = trigger_multiple.GetScriptScope();
        scope.OnVIPStartTouch <- OnVIPStartTouch;
        scope.OnVIPEndTouch <- OnVIPEndTouch;
        scope.capture_area <- capture_area;
    }
}
OnTickEnd(GiveControlPointsVIPLock);

function OnVIPStartTouch()
{
    if (IsVIP(activator))
        capture_area.AcceptInput("Enable", null, null, null);
}

function OnVIPEndTouch()
{
    if (IsVIP(activator))
        capture_area.AcceptInput("DisableAndEndTouch", null, null, null);
}

//todo temp hack
OnGameEvent("vip_gone", 0, function(player, params)
{
    for (local capture_area = null; capture_area = Entities.FindByClassname(capture_area, "trigger_capture_area");)
        capture_area.AcceptInput("DisableAndEndTouch", null, null, null);
});